#!/usr/bin/env python
import playerlib
import string
import usermsg
import es
import keyvalues
es.ServerVar("tag_ver", 1, "tag Version").makepublic()

#---------------------------------------------------------
# Tag-Mod Coded by HaloShadoW
# Large barrows from the code of "coloursay" by Saul
#
# If you need to add some more Say commands that don't have prefixes, do so with the list called SayHooks in the format that is displayed.
#---------------------------------------------------------

#List all of your say hooks that are currently in use on the server
SayHooks = ["vote","rpgmenu", "shopmenu", "wcsmenu", "rank", "statsme", "session", "thetime", "google", "rtv", "rockthevote", "nominate", "nextmap", "timeleft", "listmaps", "votemap", "hitboxme", "top", "top10", "votekick", "voteban"]

#List all the pre-fixes that need to be sent to the server without alteration 
#-In example:  /slay Viper would be sent correctly
SayFinds = ["@","/","!"]

#Add "admins" and they will get stars encasing their name rather than brackets.
Admins = ["STEAM_ID_LAN","STEAM_0:0:15285093"]


#Please pardon non-existant commenting.

def load():
    es.addons.registerSayFilter(sayFilter)
    es.regcmd("tag", "tag/writedb", "Syntax: Player-name, Tag")
es.keygroupload("tag","|tag")
tags = keyvalues.getKeyGroup("tag")
    
def unload():
    es.keygroupdelete("tag")
    es.addons.unregisterSayFilter(sayFilter)

def player_activate(ev):	
	es.tell(ev['userid'],"#multi","#defaultThis server is running #greenTag Mod #Defaultby HaloShadoW.")

def writedb():
    if es.getargc() == 3:
        userid = es.getuserid(es.getargv(1))
        plyObj = playerlib.getPlayer(userid)
        plyID = plyObj.attributes['steamid']
        plyName = plyObj.attributes['name']
        if es.exists('key', 'tag', plyID) == False:
            tags[plyID] = keyvalues.KeyValues(name=plyID)
        tags[plyID]['tag'] = es.getargv(2)
        tags[plyID]['plyName'] = plyName
        tags.save(es.getAddonPath("tag") + "/es_tag_db.txt")
        es.server.cmd('echo Tag: Database Saved')
    else:
        es.server.cmd('echo Invalid: Arguments/Syntax')
        es.server.cmd('echo Syntax: tag <PartialName> <TAG>')

def saytext2(userid,index,msg,arg1="",arg2="",arg3="",arg4=""):
    if es.exists('userid',userid):
        es.usermsg('create','saytext2','SayText2')
        es.usermsg('write','byte','saytext2',index)
        es.usermsg('write','byte','saytext2',True)
        es.usermsg('write','string','saytext2',msg)
        es.usermsg('write','string','saytext2','')
        es.usermsg('write','string','saytext2','')
        es.usermsg('write','string','saytext2','')
        es.usermsg('write','string','saytext2','')
        es.usermsg('send','saytext2',userid)
        es.usermsg('delete','saytext2')
    else:
        es.dbgmsg(0,"usermsg.py: saytext2: Player: \""+userid+"\" was not found on the server.")

def say(userid, text, teamOnly):
    text = string.strip(text, '"')
    
    if int(userid) == -1:
        es.dbgmsg(0,'Console: %s' % text)
        for ply in playerlib.getPlayerList('#all'):
            usermsg.echo(int(ply), 'Console: %s' % text)
            saytext2(int(ply), 0, '\1Console\1: %s' % text)
        
        return
    
    plyObj = playerlib.getPlayer(userid)
    if plyObj.attributes['teamid'] == 1:
        saySpec(userid, text, teamOnly)

    if plyObj.attributes['teamid'] == 2:
        sayT(userid, text, teamOnly)
    
    if plyObj.attributes['teamid'] == 3:
        sayCT(userid, text, teamOnly)
    
    del plyObj


def sayFilter(userid, text, teamOnly):
    plyObj = playerlib.getPlayer(userid)
    plyID = plyObj.attributes['steamid']
    text = string.strip(text, '"')
    for v in SayFinds:
        if text.find(v,0,1) > -1:
            return userid, text, teamOnly
    if text.lower() in SayHooks:
        return userid, text.lower(), teamOnly
    elif es.exists('key', 'tag', plyID) == True:
        es.cexec_all("playgamesound common/talk.wav")
        say(userid, text, teamOnly)
        return 0, '', teamOnly
    else:
        return userid, text, teamOnly

    
def sayT(userid, text, teamOnly):
    plyObj = playerlib.getPlayer(userid)
    plyIsDead = plyObj.attributes['isdead']
    plyName = plyObj.attributes['name']
    index = plyObj.attributes['index']
    plyID = plyObj.attributes['steamid']
    
    if teamOnly:
        if plyIsDead:
            es.dbgmsg(0,'*DEAD*(Terrorist) %s :  %s' % (plyName, text))
            for ply in playerlib.getPlayerList('#t,#dead'):
                usermsg.echo(int(ply), '*DEAD*(Terrorist) %s :  %s' % (plyName, text))
                saytext2(int(ply), index, '\1*DEAD*(Terrorist) \3%s\1 :  %s' % (plyName, text))
        else:
            es.dbgmsg(0,'(Terrorist) %s :  %s' % (plyName, text))
            for ply in playerlib.getPlayerList('#t'):
                usermsg.echo(int(ply), '(Terrorist) %s :  %s' % (plyName, text))
                saytext2(int(ply), index, '\1(Terrorist) \3%s\1 :  %s' % (plyName, text))
    else:
        if plyIsDead:
            es.dbgmsg(0,'*DEAD* %s :  %s' % (plyName, text))
            for ply in playerlib.getPlayerList('#dead'):
                usermsg.echo(int(ply), '*DEAD* %s :  %s' % (plyName, text))
                saytext2(int(ply), index, '\1*DEAD* \3%s\1 :  %s' % (plyName, text))
        else:
            es.dbgmsg(0,'%s :  %s' % (plyName, text))
            for ply in playerlib.getPlayerList('#all'):
                usermsg.echo(int(ply), '%s :  %s' % (plyName, text))
                if plyID in Admins:
                    saytext2(int(ply), index, '\1\4*%s*\3%s\1 :  %s' % (tags[plyID]['tag'], plyName, text))
                else:
                    saytext2(int(ply), index, '\1\4(%s)\3%s\1 :  %s' % (tags[plyID]['tag'], plyName, text))

def sayCT(userid, text, teamOnly):
    plyObj = playerlib.getPlayer(userid)
    plyIsDead = plyObj.attributes['isdead']
    plyName = plyObj.attributes['name']
    index = plyObj.attributes['index']
    plyID = plyObj.attributes['steamid']
    
    if teamOnly:
        if plyIsDead:
            es.dbgmsg(0,'*DEAD*(Counter-Terrorist) %s :  %s' % (plyName, text))
            for ply in playerlib.getPlayerList('#ct,#dead'):
                usermsg.echo(int(ply), '*DEAD*(Counter-Terrorist) %s :  %s' % (plyName, text))
                saytext2(int(ply), index, '\1*DEAD*(Counter-Terrorist) \3%s\1 :  %s' % (plyName, text))
        else:
            es.dbgmsg(0,'(Counter-Terrorist) %s :  %s' % (plyName, text))
            for ply in playerlib.getPlayerList('#ct'):
                usermsg.echo(int(ply), '(Counter-Terrorist) %s :  %s' % (plyName, text))
                saytext2(int(ply), index, '\1(Counter-Terrorist) \3%s\1 :  %s' % (plyName, text))
    else:
        if plyIsDead:
            es.dbgmsg(0,'*DEAD* %s :  %s' % (plyName, text))
            for ply in playerlib.getPlayerList('#dead'):
                usermsg.echo(int(ply), '*DEAD* %s :  %s' % (plyName, text))
                saytext2(int(ply), index, '\1*DEAD* \3%s\1 :  %s' % (plyName, text))
        else:
            es.dbgmsg(0,'%s :  %s' % (plyName, text))
            for ply in playerlib.getPlayerList('#all'):
                usermsg.echo(int(ply), '%s :  %s' % (plyName, text))
                if plyID in Admins:
                    saytext2(int(ply), index, '\1\4*%s*\3%s\1 :  %s' % (tags[plyID]['tag'], plyName, text))
                else:
                    saytext2(int(ply), index, '\1\4(%s)\3%s\1 :  %s' % (tags[plyID]['tag'], plyName, text))

def saySpec(userid, text, teamOnly):
    plyObj = playerlib.getPlayer(userid)
    plyIsDead = plyObj.attributes['isdead']
    plyName = plyObj.attributes['name']
    index = plyObj.attributes['index']
    
    if teamOnly:
        es.dbgmsg(0,'(Spectator) %s :  %s' % (plyName, text))
        for ply in playerlib.getPlayerList('#spec,#dead'):
            usermsg.echo(int(ply), '(Spectator) %s :  %s' % (plyName, text))
            saytext2(int(ply), index, '\1(Spectator) \3%s\1 :  %s' % (plyName, text))
    else:
        es.dbgmsg(0,'*SPEC* %s :  %s' % (plyName, text))
        for ply in playerlib.getPlayerList('#dead'):
            usermsg.echo(int(ply), '*SPEC* %s :  %s' % (plyName, text))
            saytext2(int(ply), index, '\1*SPEC* \3%s\1 :  %s' % (plyName, text))
